// Author: Professor William Killian
// Date: 2019 June 13
// Class: CSCI 362.93 - Data Structures
// Assignment: 5b - PriorityQueue (Heaps of Fun)
//
// A high-level description of what this file provides/does should go here

#ifndef HEAP_UTILS_HPP_
#define HEAP_UTILS_HPP_

#include <iterator>
#include <utility>
#include <vector>

namespace HeapUtils
{

namespace detail
{

/* [2] returns the parent's index
 *
 * p: the zero-based node index
 */
constexpr size_t
parent (size_t p) noexcept
{
  // TODO
  return 0;
}

/* [2] returns the left child's index
 *
 * p: the zero-based node index
 */
constexpr size_t
left_child (size_t p) noexcept
{
  // TODO
  return 0;
}

/* [2] returns the right child's index
 *
 * p: the zero-based node index
 */
constexpr size_t
right_child (size_t p) noexcept
{
  // TODO
  return 0;
}

/* [2] returns the last interior node's index
 *
 * s: the size of the heap
 */
size_t
last_interior (size_t s) noexcept
{
  // TODO
  return 0;
}

/* [2] returns the index of the maximum child of the node at index "pos"
 *
 * v: a vector representing a heap
 * pos: the zero-based index of a node
 * size: the logical size of the heap (may not be equal to v.size())
 * comp: a comparator function object
 */
template<typename T, typename Comp>
constexpr inline size_t
max_child (std::vector<T> const& v, size_t const pos, size_t const size, Comp& comp) noexcept
{
  size_t lchild = left_child (pos);
  size_t rchild = right_child (pos);
  // TODO
  // hint: use size to determine if lchild or rchild "exist"
}

/* down-heaps a node at index "curr" into place
 *
 * v: a vector representing a heap
 * curr: the zero-based index of a node
 * size: logical size of heap (may not be equal to v.size())
 * comp: a comparator function object
 */
template<class T, class Comp>
void
sift_down (std::vector<T>& v, size_t curr, size_t size, Comp& comp) noexcept
{
  // TODO
  // if the heap is too small or we have no children:
  //   do nothing

  // determine child
  // store "curr" value
  // while we are not in heap order
  //   assign "curr" value to "child" value
  //   if child is a leaf:
  //     break
  //   update curr to child
  //   update child to its max_child
}

/* up-heaps a node at index "curr" into place
 *
 * v: a vector representing a heap
 * curr: the zero-based index of a node
 * comp: a comparator function object
 */
template<class T, class Comp>
void
sift_up (std::vector<T>& v, size_t curr, Comp& comp) noexcept
{
  // TODO

  // if we are at the root, do nothing
  //
  // determine parent
  // store "curr" value
  // while we are not in heap order:
  //   assign "curr" value to "parent" value
  //   if our parent is the root:
  //     break
  //   update curr to parent
  //   update parent to its parent
}

} // end namespace internal

/* modifies v to become a heap. Starts at the last interior node and downHeaps
 * each node until the root has been downHeaped
 *
 * v: a vector representing a heap
 * comp: a comparator function object
 */
template<class T, class Comp>
void
make_heap (std::vector<T>& v, Comp& comp) noexcept
{
  using namespace detail;
  // TODO
  // if the vector is empty, do nothing
  // start from the "last" interior node and work back to root
  //   and sift down for each
}

/* "inserts" a new element into the heap. The new element must reside
 * at index v.size() - 1. Essentially calls upHeap(v.size() - 1)
 *
 * Preconditions:
 * - v.size() > 0
 * - v.back() was just added to the vector and may not be in place
 *
 * Postconditions:
 * - v is a heap
 *
 * v: a vector representing a heap
 * comp: a comparator function object
 */
template<class T, class Comp>
void
push_heap (std::vector<T>& v, Comp& comp) noexcept
{
  using namespace detail;
  // TODO
  // if vector has 0 or 1 elements, do nothing
  // start at the last index of the vector (cursor)
  // and sift up
}

/* "removes" the max element in the heap (and places it at index
 * v.size() - 1). Essentially swaps front() with back() and then
 * performs downHeap from index zero
 *
 * Preconditions:
 * - v cannot be empty
 *
 * Postconditions:
 * - v is a heap under the bounds [0, v.size() - 1)
 *
 * v: a vector representing a heap
 * comp: a comparator function object
 */
template<class T, class Comp>
void
pop_heap (std::vector<T>& v, Comp& comp) noexcept
{
  using namespace detail;
  // TODO
  // if we have at least two elements
  //   swap front and back
  //   sift down from "front"
}

/* determines whether or not v is a heap (given the comparator)
 * returns true IFF v is a valid heap
 *
 * v: a vector
 * comp: a comparator object
 */
template<class T, class Comp>
bool
is_heap (std::vector<T> const& v, Comp& comp) noexcept
{
  // hint: keep track of the parent and walk through each node
  //       starting at root's left. if comparing "parent" to "curr",
  //       is true, than it's not in heap order
  return true;
}

} // end namespace HeapUtils

#endif
