// Author: Professor William Killian
// Date: 2019 June 13
// Class: CSCI 362.93 - Data Structures
// Assignment: 5b - PriorityQueue (Heaps of Fun)
//
// A high-level description of what this file provides/does should go here

#ifndef PRIORITY_QUEUE_HPP_
#define PRIORITY_QUEUE_HPP_

#include <functional>
#include <utility>
#include <vector>

#include "HeapUtils.hpp"

template<class T, class Comp = std::less<T>>
class PriorityQueue
{
public:
  using container_type = std::vector<T>;
  using value_compare = Comp;
  using value_type = T;
  using reference = T &;
  using const_reference = T const &;
  using size_type = size_t;

  PriorityQueue ()
    : c (), comp ()
  {
  }

  PriorityQueue (PriorityQueue const &pq)
    : c (pq.c), comp (pq.comp)
  {
  }

  PriorityQueue (PriorityQueue &&pq)
    : c (std::move (pq.c)), comp (std::move (pq.comp))
  {
  }

  template<class InputIt>
  PriorityQueue (InputIt first, InputIt last, Comp const &comp)
    : PriorityQueue (comp, container_type (first, last))
  {
  }

  explicit PriorityQueue (Comp const &comp)
    : PriorityQueue (comp, container_type ())
  {
  }

  // [2] construct a priority queue from a comparator and underlying container
  PriorityQueue (Comp const &comp, container_type const &c)
    : c (c), comp (comp)
  {
    // TODO -- need to take the container and turn it into a heap

  }

  // [2] construct a priority queue from a comparator and underlying (r-value) container
  explicit PriorityQueue (Comp const &comp, container_type &&c)
    : c (std::move (c)), comp (comp)
  {
    // TODO -- need to take the container and turn it into a heap

  }

  PriorityQueue &
  operator= (PriorityQueue const &pq)
  {
    if (this != &pq)
    {
      c = pq.c;
      comp = pq.comp;
    }
    return *this;
  }

  PriorityQueue &
  operator= (PriorityQueue &&pq)
  {
    c = std::move (pq.c);
    comp = std::move (pq.comp);
    return *this;
  }

  // [2] return True IFF the heap is empty
  bool
  empty () const
  {
    // TODO

  }

  // [2] return the size of the heap
  size_type
  size () const
  {
    // TODO

  }

  // [2] return the top of the heap
  const_reference
  top () const
  {
    // TODO

  }

  // [2] insert the new element "v" into the heap
  void
  push (value_type const &v)
  {
    // TODO


  }

  // [2] insert the new element "v" into the heap
  void
  push (value_type &&v)
  {
    // TODO
    // hint: same as above... just say std::move(v) instead of v


  }

  template<class... Args>
  void
  emplace (Args &&... args)
  {
    c.emplace_back (std::forward<Args> (args)...);
    HeapUtils::push_heap (c, comp);
  }

  // [2] remove the top element from the heap
  void
  pop ()
  {
    // TODO

  }

  void
  swap (PriorityQueue &pq)
  {
    using std::swap;
    swap (c, pq.c);
    swap (comp, pq.comp);
  }

protected:
  container_type c;
  value_compare comp;
};

namespace std
{
template<class T, class Comp>
void
swap (PriorityQueue<T, Comp> &x, PriorityQueue<T, Comp> &y)
{
  x.swap (y);
}

} // namespace std

#endif
